-- Ursus 5314
-- by badziu
-- 6.06.2009
-- all rights reserved
Ursus_5314 = {};

function Ursus_5314.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Ursus_5314:load(xmlFile)
    self.kogutAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kogut#count"),0);
    self.kogutKey = getXMLString(xmlFile, "vehicle.kogut#key");
    self.kogutAn = false;
    self.kogut = {};
    for i=1, self.kogutAnz do
        local objname = string.format("vehicle.kogut.light" .. "%d",i);
        self.kogut[i] = {};
        self.kogut[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.kogut[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.kogut[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.kogut[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.kogut[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.kogut[i].emit and self.kogut[i].source ~= nil then
           setVisibility(self.kogut[i].source, false);
        end;
    end;
	self.halogenyprzod = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.halogeny_przod#index"));
	self.halogenytyl = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.halogeny_tyl#index"));
	 self.numpodswietlenies = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.swiatlo_wewnatrz#count"), 0);
    self.podswietlenies = {};
    for i=1, self.numpodswietlenies do
        local podswietlenienamei = string.format("vehicle.swiatlo_wewnatrz.swiatlo_wewnatrz" .. "%d", i);
        self.podswietlenies[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, podswietlenienamei .. "#index"));
        setVisibility(self.podswietlenies[i], false);
    end;
    local rotationPartNodebackwindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tylna_szyba#index"));
    if rotationPartNodebackwindow ~= nil then
        self.rotationPartbackwindow = {};
        self.rotationPartbackwindow.node = rotationPartNodebackwindow;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttylna_szyba#minRot"));
        self.rotationPartbackwindow.minRot = {};
        self.rotationPartbackwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tylna_szyba#maxRot"));
        self.rotationPartbackwindow.maxRot = {};
        self.rotationPartbackwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartbackwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tylna_szyba#rotTime"), 2)*1000;
        self.rotationPartbackwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tylna_szyba#touchRotLimit"), 10));
    end;
	
	local rotationPartNodetloczki = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tloki#index"));
    if rotationPartNodetloczki ~= nil then
        self.rotationParttloczki = {};
        self.rotationParttloczki.node = rotationPartNodetloczki;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttloki#minRot"));
        self.rotationParttloczki.minRot = {};
        self.rotationParttloczki.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttloczki.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttloczki.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tloki#maxRot"));
        self.rotationParttloczki.maxRot = {};
        self.rotationParttloczki.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttloczki.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttloczki.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttloczki.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tloki#rotTime"), 2)*1000;
        self.rotationParttloczki.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tloki#touchRotLimit"), 10));
    end;

	self.kierunek = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kierunek_lewy#index"));	
	self.kierunekActive = false;
	
    self.kierunek2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kierunek_prawy#index"));	
	self.kierunek2Active = false;

	
		turn1SoundFile = Utils.getFilename("turn1.wav", self.baseDirectory);
    self.turn1 = createSample("turn1");
    loadSample(self.turn1, turn1SoundFile, false);
	
	turn2SoundFile = Utils.getFilename("turn2.wav", self.baseDirectory);
    self.turn2 = createSample("turn2");
    loadSample(self.turn2, turn2SoundFile, false);

	self.lusterka = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lusterka#index"));
	self.ignitionKey = false;
	self.allowedIgnition = false;                                                  
	self.motorStopSoundVolume2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#volume"), 1.0);
		
	local rotationPartNodedach = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.dach#index"));
    if rotationPartNodedach ~= nil then
        self.rotationPartdach = {};
        self.rotationPartdach.node = rotationPartNodedach;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartdach#minRot"));
        self.rotationPartdach.minRot = {};
        self.rotationPartdach.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartdach.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartdach.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.dach#maxRot"));
        self.rotationPartdach.maxRot = {};
        self.rotationPartdach.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartdach.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartdach.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartdach.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.dach#rotTime"), 2)*1000;
        self.rotationPartdach.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.dach#touchRotLimit"), 10));
    end;
	
	local lewedrzwiNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lewe_drzwi#index"));
		if lewedrzwiNode ~= nil then
        self.lewedrzwi = {};
        self.lewedrzwi.node = lewedrzwiNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.lewe_drzwi#minRot"));
        self.lewedrzwi.minRot = {};
        self.lewedrzwi.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.lewedrzwi.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.lewedrzwi.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.lewe_drzwi#maxRot"));
        self.lewedrzwi.maxRot = {};
        self.lewedrzwi.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.lewedrzwi.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.lewedrzwi.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.lewedrzwi.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.lewe_drzwi#rotTime"), 2)*1000;
        self.lewedrzwi.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.lewe_drzwi#touchRotLimit"), 10));
    end;
 local prawedrzwiNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.prawe_drzwi#index"));
    if prawedrzwiNode ~= nil then
        self.prawedrzwi = {};
        self.prawedrzwi.node = prawedrzwiNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.prawe_drzwi#minRot"));
        self.prawedrzwi.minRot = {};
        self.prawedrzwi.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.prawedrzwi.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.prawedrzwi.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.prawe_drzwi#maxRot"));
        self.prawedrzwi.maxRot = {};
        self.prawedrzwi.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.prawedrzwi.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.prawedrzwi.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.prawedrzwi.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.prawe_drzwi#rotTime"), 2)*1000;
        self.prawedrzwi.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.prawe_drzwi#touchRotLimit"), 10));
    end;			
    local rotationPartNodewycieraczka2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wycieraczka#index"));
    if rotationPartNodewycieraczka2 ~= nil then
        self.rotationPartwycieraczka2 = {};
        self.rotationPartwycieraczka2.node = rotationPartNodewycieraczka2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwycieraczka#minRot"));
        self.rotationPartwycieraczka2.minRot = {};
        self.rotationPartwycieraczka2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwycieraczka2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwycieraczka2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wycieraczka#maxRot"));
        self.rotationPartwycieraczka2.maxRot = {};
        self.rotationPartwycieraczka2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwycieraczka2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwycieraczka2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwycieraczka2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wycieraczka#rotTime"), 2)*1000;
        self.rotationPartwycieraczka2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wycieraczka#touchRotLimit"), 10));
    end;			

	wycieraczkaSoundFile = Utils.getFilename("wycieraczka.wav", self.baseDirectory);
    self.wycieraczkaSoundId = createSample("wycieraczkaSound");
	loadSample(self.wycieraczkaSoundId, wycieraczkaSoundFile, false);
	self.wycieraczkaPlaying = false;
	self.recznylight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.recznylight#index"));
    self.hamuleclight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hamulec_light#index"));
	self.controlpath = Utils.getFilename("skrzynia.png", self.baseDirectory);
    self.ursushudWidth = 0.256;
    self.ursushudHeight = 0.316;
	self.ursushudPoxX = 0.7;
    self.ursushudPoxY = 1-1.16;
    self.ursushudOverlay = Overlay:new("ursushudControl", self.controlpath, self.ursushudPoxX, self.ursushudPoxY, self.ursushudWidth, self.ursushudHeight);
	self.gang0 = true;
	self.handbrake = true;
    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 800);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1800);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;
	self.exhaustParticleSystems2 = {};
    local psName = "vehicle.exhaustParticleSystemExtra1";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems2, psName, self.rootNode, false, nil, self.baseDirectory)
	self.exhaustParticleSystems3 = {};
    local psName = "vehicle.exhaustParticleSystemExtra2";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems3, psName, self.rootNode, false, nil, self.baseDirectory)
	self.exhaustParticleSystems4 = {};
    local psName = "vehicle.exhaustParticleSystemExtra3";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems4, psName, self.rootNode, false, nil, self.baseDirectory)
	self.exhaustParticleSystems5 = {};
    local psName = "vehicle.exhaustParticleSystemExtra4";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems5, psName, self.rootNode, false, nil, self.baseDirectory)
	brakereleaseSoundFile = Utils.getFilename("hamulec.wav", self.baseDirectory);
    self.brakereleaseSoundId = createSample("brakereleaseSound");
    loadSample(self.brakereleaseSoundId, brakereleaseSoundFile, false);
    self.brakereleasePlaying = false;
	handbrakeSoundFile = Utils.getFilename("hamulec2.wav", self.baseDirectory);
    self.handbrakeSoundId = createSample("handbrakeSound");
    loadSample(self.handbrakeSoundId, handbrakeSoundFile, false);
    self.handbrakePlaying = false;
	self.blizniak = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.blizniak#index"));
	self.blizniak2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.blizniak2#index"));
	self.blizniak3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.blizniak3#index"));
	self.blizniak4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.blizniak4#index"));
	self.naped = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.naped#index"));
	local wajchagazNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha_gaz#index"));
    if wajchagazNode ~= nil then
        self.wajchagaz = {};
        self.wajchagaz.node = wajchagazNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha_gaz#minRot"));
        self.wajchagaz.minRot = {};
        self.wajchagaz.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wajchagaz.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wajchagaz.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha_gaz#maxRot"));
        self.wajchagaz.maxRot = {};
        self.wajchagaz.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wajchagaz.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wajchagaz.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.wajchagaz.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha_gaz#rotTime"), 2)*1000;
        self.wajchagaz.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha_gaz#touchRotLimit"), 10));
    end;
	local rotationPartNodepedalgazu = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pedal_gazu#index"));
    if rotationPartNodepedalgazu ~= nil then
        self.rotationPartpedalgazu = {};
        self.rotationPartpedalgazu.node = rotationPartNodepedalgazu;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_gazu#minRot"));
        self.rotationPartpedalgazu.minRot = {};
        self.rotationPartpedalgazu.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalgazu.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalgazu.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_gazu#maxRot"));
        self.rotationPartpedalgazu.maxRot = {};
        self.rotationPartpedalgazu.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalgazu.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalgazu.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpedalgazu.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_gazu#rotTime"), 2)*1000;
        self.rotationPartpedalgazu.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_gazu#touchRotLimit"), 10));
    end;
	local rotationPartNodesprzeglo = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.sprzeglo#index"));
    if rotationPartNodesprzeglo ~= nil then
        self.rotationPartsprzeglo = {};
        self.rotationPartsprzeglo.node = rotationPartNodesprzeglo;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.sprzeglo#minRot"));
        self.rotationPartsprzeglo.minRot = {};
        self.rotationPartsprzeglo.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartsprzeglo.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartsprzeglo.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.sprzeglo#maxRot"));
        self.rotationPartsprzeglo.maxRot = {};
        self.rotationPartsprzeglo.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartsprzeglo.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartsprzeglo.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartsprzeglo.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.sprzeglo#rotTime"), 2)*1000;
        self.rotationPartsprzeglo.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.sprzeglo#touchRotLimit"), 10));
    end
	local rotationPartNodepedalhamulca = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pedal_hamulca#index"));
    if rotationPartNodepedalhamulca ~= nil then
        self.rotationPartpedalhamulca = {};
        self.rotationPartpedalhamulca.node = rotationPartNodepedalhamulca;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_hamulca#minRot"));
        self.rotationPartpedalhamulca.minRot = {};
        self.rotationPartpedalhamulca.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalhamulca.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalhamulca.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_hamulca#maxRot"));
        self.rotationPartpedalhamulca.maxRot = {};
        self.rotationPartpedalhamulca.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalhamulca.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalhamulca.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpedalhamulca.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_hamulca#rotTime"), 2)*1000;
        self.rotationPartpedalhamulca.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_hamulca#touchRotLimit"), 10));
    end;
	local rotationPartNodekluczyk = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kluczyk#index"));
    if rotationPartNodekluczyk ~= nil then
        self.rotationPartkluczyk = {};
        self.rotationPartkluczyk.node = rotationPartNodekluczyk;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kluczyk#minRot"));
        self.rotationPartkluczyk.minRot = {};
        self.rotationPartkluczyk.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkluczyk.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkluczyk.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kluczyk#maxRot"));
        self.rotationPartkluczyk.maxRot = {};
        self.rotationPartkluczyk.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkluczyk.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkluczyk.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkluczyk.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kluczyk#rotTime"), 2)*1000;
        self.rotationPartkluczyk.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.kluczyk#touchRotLimit"), 10));
    end;
	local rotationPartNodewlswiatel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wlacznik_swiatel#index"));
    if rotationPartNodewlswiatel ~= nil then
        self.rotationPartwlswiatel = {};
        self.rotationPartwlswiatel.node = rotationPartNodewlswiatel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wlacznik_swiatel#minRot"));
        self.rotationPartwlswiatel.minRot = {};
        self.rotationPartwlswiatel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwlswiatel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwlswiatel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wlacznik_swiatel#maxRot"));
        self.rotationPartwlswiatel.maxRot = {};
        self.rotationPartwlswiatel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwlswiatel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwlswiatel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwlswiatel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wlacznik_swiatel#rotTime"), 2)*1000;
        self.rotationPartwlswiatel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wlacznik_swiatel#touchRotLimit"), 10));
    end;
	local rotationPartNodewajchabiegir = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajchabiegiR#index"));
    if rotationPartNodewajchabiegir ~= nil then
        self.rotationPartwajchabiegir = {};
        self.rotationPartwajchabiegir.node = rotationPartNodewajchabiegir;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegiR#minRot"));
        self.rotationPartwajchabiegir.minRot = {};
        self.rotationPartwajchabiegir.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegir.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegir.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegiR#maxRot"));
        self.rotationPartwajchabiegir.maxRot = {};
        self.rotationPartwajchabiegir.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegir.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegir.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajchabiegir.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegiR#rotTime"), 2)*1000;
        self.rotationPartwajchabiegir.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegiR#touchRotLimit"), 10));
    end;
	
	local rotationPartNodewajchabiegi1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajchabiegi1#index"));
    if rotationPartNodewajchabiegi1 ~= nil then
        self.rotationPartwajchabiegi1 = {};
        self.rotationPartwajchabiegi1.node = rotationPartNodewajchabiegi1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi1#minRot"));
        self.rotationPartwajchabiegi1.minRot = {};
        self.rotationPartwajchabiegi1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi1#maxRot"));
        self.rotationPartwajchabiegi1.maxRot = {};
        self.rotationPartwajchabiegi1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajchabiegi1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi1#rotTime"), 2)*1000;
        self.rotationPartwajchabiegi1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi1#touchRotLimit"), 10));
    end;
	
	local rotationPartNodewajchabiegi2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajchabiegi2#index"));
    if rotationPartNodewajchabiegi2 ~= nil then
        self.rotationPartwajchabiegi2 = {};
        self.rotationPartwajchabiegi2.node = rotationPartNodewajchabiegi2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi2#minRot"));
        self.rotationPartwajchabiegi2.minRot = {};
        self.rotationPartwajchabiegi2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi2#maxRot"));
        self.rotationPartwajchabiegi2.maxRot = {};
        self.rotationPartwajchabiegi2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajchabiegi2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi2#rotTime"), 2)*1000;
        self.rotationPartwajchabiegi2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi2#touchRotLimit"), 10));
    end;
	
	local rotationPartNodewajchabiegi3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajchabiegi3#index"));
    if rotationPartNodewajchabiegi3 ~= nil then
        self.rotationPartwajchabiegi3 = {};
        self.rotationPartwajchabiegi3.node = rotationPartNodewajchabiegi3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi3#minRot"));
        self.rotationPartwajchabiegi3.minRot = {};
        self.rotationPartwajchabiegi3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi3#maxRot"));
        self.rotationPartwajchabiegi3.maxRot = {};
        self.rotationPartwajchabiegi3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajchabiegi3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi3#rotTime"), 2)*1000;
        self.rotationPartwajchabiegi3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi3#touchRotLimit"), 10));
    end;
	
	local rotationPartNodewajchabiegi4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajchabiegi4#index"));
    if rotationPartNodewajchabiegi4 ~= nil then
        self.rotationPartwajchabiegi4 = {};
        self.rotationPartwajchabiegi4.node = rotationPartNodewajchabiegi4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi4#minRot"));
        self.rotationPartwajchabiegi4.minRot = {};
        self.rotationPartwajchabiegi4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajchabiegi4#maxRot"));
        self.rotationPartwajchabiegi4.maxRot = {};
        self.rotationPartwajchabiegi4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajchabiegi4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajchabiegi4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajchabiegi4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi4#rotTime"), 2)*1000;
        self.rotationPartwajchabiegi4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajchabiegi4#touchRotLimit"), 10));
    end;
	local radioSound = getXMLString(xmlFile, "vehicle.radioSound#file");
    if  radioSound ~= nil and  radioSound ~= "" then
        radioSound = Utils.getFilename( radioSound, self.baseDirectory); 
        self.radioSound = createSample(" radioSound");
        self.radioSoundPlaying = false;
        loadSample(self. radioSound, radioSound, false);
        self.radioSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.radioSound#volume"),1);
    end;
	self.blizniak4Active = false;
	self.blizniak3Active = false;
	self.blizniak2Active = false;
	self.blizniakActive = false;
	self.test = 800;
	self.rotationMaxdachActive = true;	
	self.rotationMaxbackwindowActive = true;
	self.lusterkaActive = false;
	self.halogenyprzodActive = false; 
	self.halogenytylActive = false;
end;

function Ursus_5314:keyEvent(unicode, sym, modifier, isDown)
    if self.isEntered then
      if self.kogutKey ~= nil then
         if isDown and sym == Input[self.kogutKey] then
           self.kogutAn = not self.kogutAn;
           for i=1, self.kogutAnz do
             setVisibility(self.kogut[i].light, self.kogutAn);
           end;
         end;
      end;
    end;
    if isDown and sym == Input.KEY_z then
		self.halogenyprzodActive = not self.halogenyprzodActive;
	end;
 if isDown and sym == 48 then -- Key: 0
		self.pomoc = not self.pomoc;
    end;	
	if isDown and sym == Input.KEY_5 then
		self.halogenytylActive = not self.halogenytylActive;
	end;	
if isDown and sym == Input.KEY_8 then 
		self.rotationMaxbackwindow = not self.rotationMaxbackwindow;
		self.rotationMaxtloczki = not self.rotationMaxtloczki;
	end;
	if isDown and sym == Input.KEY_KP_6 then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashlightsRightActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsRight2Active = false;
		self.kierunek2Active = false;
		self.flashWarner = false;
	end;
	
	if isDown and sym == Input.KEY_KP_5 then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashlightsRightActive = false;
		self.flashlightsLeftActive = false;
		self.flashWarner = not self.flashWarner;
	end;
	
	if isDown and sym == Input.KEY_KP_4 then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashlightsLeftActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsLeft2Active = false;
		self.kierunekActive = false;
		self.flashWarner = false;
	end;
    if isDown and sym == Input.KEY_9 then
		self.lusterkaActive = not self.lusterkaActive;
	end;
	if isDown and sym == Input.KEY_6 then 
		self.rotationMaxdach = not self.rotationMaxdach;
	end;	
	if sym == Input.KEY_KP_8 then
		self.lewedrzwiMax = isDown;
	end;
	if sym == Input.KEY_KP_9 then
		self.lewedrzwiMin = isDown;
	end;
	if sym == Input.KEY_KP_2 then
		self.prawedrzwiMax = isDown;
	end;
	if sym == Input.KEY_KP_3 then
		self.prawedrzwiMin = isDown;
	end;	
	if isDown and sym == Input.KEY_KP_7 then 
		self.wycieraczka = not self.wycieraczka;
	end;	
	if not self.skrzynia then
	if isDown and sym == Input.KEY_pageup then
			if self.gang01 == true then
				self.gang0 = true;
				self.rotationMaxwajchabiegir = false;
				self.gang01 = false;
			elseif self.gang0 == true then
				self.reverse = false;
				self.gang1 = true;
				self.gang0 = false;
				self.rotationMaxwajchabiegi1 = true;
			elseif self.gang1 == true then
				self.gang2 = true;
				self.gang1 = false;
				self.rotationMaxwajchabiegi1 = false;
				self.rotationMaxwajchabiegi2 = true;
			elseif self.gang2 == true then
				self.gang3 = true;
				self.gang2 = false;
				self.rotationMaxwajchabiegi2 = false;
				self.rotationMaxwajchabiegi3 = true;
			elseif self.gang3 == true then
				self.gang4 = true;
				self.gang3 = false;
				self.rotationMaxwajchabiegi3 = false;
				self.rotationMaxwajchabiegi4 = true;
			end;
		end;
	
		if isDown and sym == Input.KEY_pagedown then
			if self.gang4 == true then
				self.gang3 = true;
				self.gang4 = false;
				self.rotationMaxwajchabiegi3 = true;
				self.rotationMaxwajchabiegi4 = false;
			elseif self.gang3 == true then
				self.gang2 = true;
				self.gang3 = false;
				self.rotationMaxwajchabiegi2 = true;
				self.rotationMaxwajchabiegi3 = false;
			elseif self.gang2 == true then
				self.gang1 = true;
				self.gang2 = false;
				self.rotationMaxwajchabiegi1 = true;
				self.rotationMaxwajchabiegi2 = false;
			elseif self.gang1 == true then
				self.gang0 = true;
				self.gang1 = false;
				self.rotationMaxwajchabiegi1 = false;
			elseif self.gang0 == true then
				self.gang01 = true;
				self.reverse = true;
				self.gang0 = false;
				self.rotationMaxwajchabiegir = true;
			end;
		end;
	end;
	if isDown and sym == Input.KEY_space then
		self.handbrake = not self.handbrake;
		if self.handbrake then
			playSample(self.handbrakeSoundId,1,1,0);
		end;
	end;
	if isDown and sym == Input.KEY_KP_1 then 
				self.blizniakActive = not self.blizniakActive;
				self.blizniak2Active = not self.blizniak2Active;
			end;	
	if isDown and sym == Input.KEY_KP_0 then 
			self.blizniak3Active = not self.blizniak3Active;
			self.blizniak4Active = not self.blizniak4Active;
		end;	
	if sym == Input.KEY_KP_minus then
		self.wajchagazMax = isDown;
		end;
	if sym == Input.KEY_KP_plus then
		self.wajchagazMin = isDown;
		end;
	 if isDown and sym == Input.KEY_r then 
		self.swiatla = not self.swiatla;
		end;
end;

function Ursus_5314:update(dt)
    if self.isEntered then
  if self.isEntered then
    if self.kogutAnz > 0 then
      if self.kogutAn then
        for i=1, self.kogutAnz do
          rotate(self.kogut[i].rotNode, 0, dt*self.kogut[i].speed, 0);
        end;
      end;
    end;
  end;
	setVisibility(self.halogenyprzod, self.halogenyprzodActive);
	setVisibility(self.halogenytyl, self.halogenytylActive);
end;
if self.rotationPartbackwindow ~= nil then
		local x, y, z = getRotation(self.rotationPartbackwindow.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartbackwindow.maxRot, self.rotationPartbackwindow.minRot, 3, self.rotationPartbackwindow.rotTime, dt, not self.rotationMaxbackwindow);
		setRotation(self.rotationPartbackwindow.node, unpack(newRot));
   end;	
	
if self.rotationParttloczki ~= nil then
		local x, y, z = getRotation(self.rotationParttloczki.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttloczki.maxRot, self.rotationParttloczki.minRot, 3, self.rotationParttloczki.rotTime, dt, not self.rotationMaxtloczki);
		setRotation(self.rotationParttloczki.node, unpack(newRot));
   end;		
	if self.flash then
		if self.delayOn >= 0 then
			self.delayOn = self.delayOn -dt;
		end;
		if not self.flashlightsRightActive then
			if self.delayOn < 0 then
				self.delayOff = 500;
				self.flashlightsRightActive = true;
				self.flashlightsLeftActive = true;
				self.flashlightsWarnerActive = true;
				self.kierunek2Active = true;
				self.kierunekActive = true;
				playSample(self.turn1, 1, 0.7, 0);
			end;
		end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.flashlightsLeftActive = false;
				self.flashlightsRightActive = false;
				self.flashlightsWarnerActive = false;
				self.kierunek2Active = false;
				self.kierunekActive = false;
				playSample(self.turn2, 1, 0.7, 0);
			end;
		end;
	end;
	
	if self.flashRight then
		if self.delayOnRight >= 0 then
			self.delayOnRight = self.delayOnRight -dt;
		end;
		if not self.flashlightsRightActive then
			if self.delayOnRight < 0 then
				self.delayOffRight = 500;
				self.flashlightsRightActive = true;
				self.kierunek2Active = true;
				playSample(self.turn1,1,0.7,0);
			end;
		end;
		if self.delayOffRight >= 0 then
			self.delayOffRight = self.delayOffRight -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOffRight < 0 then
				self.delayOnRight = 500;
				self.flashlightsRightActive = false;
				self.kierunek2Active = false;
				playSample(self.turn2,1,0.7,0);
			end;
		end;
	else
		if not self.flashWarner then
			self.kierunek2Active = false;
		end;
	end;
	if self.flashLeft then
			if self.delayOnLeft >= -1 then
				self.delayOnLeft = self.delayOnLeft -dt;
			end;
			if not self.flashlightsLeftActive then
				if self.delayOnLeft < 0 then
					self.delayOffLeft = 500;
					self.flashlightsLeftActive = true;
					self.kierunekActive = true;
					playSample(self.turn1,1,0.7,0);
				end;
			end;
			if self.delayOffLeft >= 0 then
				self.delayOffLeft = self.delayOffLeft -dt;
			end;
			if self.flashlightsLeftActive then
				if self.delayOffLeft < 0 then
					self.delayOnLeft = 500;
					self.flashlightsLeftActive = false;
					self.kierunekActive = false;
					playSample(self.turn2,1,0.7,0);
				end;
			end;
		else
			if not self.flashWarner then
				self.kierunekActive = false;
			end;
		end;
	setVisibility(self.kierunek, self.kierunekActive);
	setVisibility(self.kierunek2, self.kierunek2Active);

setVisibility(self.lusterka, self.lusterkaActive);



   
		

if self.rotationPartdach ~= nil then
		local x, y, z = getRotation(self.rotationPartdach.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartdach.maxRot, self.rotationPartdach.minRot, 3, self.rotationPartdach.rotTime, dt, not self.rotationMaxdach);
		setRotation(self.rotationPartdach.node, unpack(newRot));
   end;	
			
		


local doRotate = self.lewedrzwiMax or self.lewedrzwiMin 
	if self.lewedrzwi ~= nil and doRotate then
        	local x, y, z = getRotation(self.lewedrzwi.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.lewedrzwi.maxRot, self.lewedrzwi.minRot, 3, self.lewedrzwi.rotTime, dt, not self.lewedrzwiMax);
        	setRotation(self.lewedrzwi.node, unpack(newRot));
	end;	
	local doRotate = self.prawedrzwiMax or self.prawedrzwiMin 
	if self.prawedrzwi ~= nil and doRotate then
        	local x, y, z = getRotation(self.prawedrzwi.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.prawedrzwi.maxRot, self.prawedrzwi.minRot, 3, self.prawedrzwi.rotTime, dt, not self.prawedrzwiMax);
        	setRotation(self.prawedrzwi.node, unpack(newRot));
	end;
if self.wycieraczka then
		self.test = self.test - dt;
		if self.test < 0 then
				self.rotationMaxwycieraczka2 = not self.rotationMaxwycieraczka2;
				playSample(self.wycieraczkaSoundId,1,1,0);
			self.test = 1000;
		end;

	end;	
if self.rotationPartwycieraczka2 ~= nil then
		local x, y, z = getRotation(self.rotationPartwycieraczka2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwycieraczka2.maxRot, self.rotationPartwycieraczka2.minRot, 3, self.rotationPartwycieraczka2.rotTime, dt, not self.rotationMaxwycieraczka2);
		setRotation(self.rotationPartwycieraczka2.node, unpack(newRot));
   end;	
 if self.isMotorStarted then
		if self.isEntered then

        local acceleration = 0;
		local brakeTorque;
        if g_currentMission.allowSteerableMoving and not self.playMotorSound then
           
			if self.reverse then
				if self.gang01 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = -0.05;
					end;
				
				end;
			else
				if self.gang0 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0;
					end;
				elseif self.gang1 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.04;
					end;
				elseif self.gang2 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.17;
					end;
				elseif self.gang3 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						if self.motor.lastMotorRpm < 1800 then
							acceleration = 0.35;
						elseif self.motor.lastMotorRpm > 1800 then
							acceleration = 0.55;
						end;
					end;
				elseif self.gang4 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						if self.motor.lastMotorRpm < 2300 then
							acceleration = 0.6;
						elseif self.motor.lastMotorRpm > 2300 then
							acceleration = 1.0;
						end;
					end;
				
				
				end;
			end;
			
			if Input.isKeyPressed(Input.KEY_w) then
				self.motor:setSpeedLevel(0, true)
			end;
			if Input.isKeyPressed(Input.KEY_w) then
				self.motor:setSpeedLevel(0,true)
			end;
			
 end;
			

		if not self.handbrake then
			brakeTorque = 0.00001;
			self.motor.brakeForce = brakeTorque;
			setVisibility(self.recznylight, false);
		else
			if not Input.isKeyPressed(Input.KEY_s) then
				brakeTorque = 20;
				self.motor.brakeForce = brakeTorque;
				acceleration = 0;
				setVisibility(self.recznylight, true);
			end;
		end;		
		if Input.isKeyPressed(Input.KEY_s) then
			if not self.druckWarning then
				
				brakeTorque = 20;
				setVisibility(self.hamuleclight, true);
				self.motor.brakeForce = brakeTorque;
				acceleration = 0;
				if not self.brakePlaying then
					playSample(self.brakeSoundId,1,1,0);
					self.brakePlaying = true;
				end;
				self.brakereleasePlaying = false;				
			end;
		else
			self.brakePlaying = false;
			setVisibility(self.hamuleclight, false);
			self.braking = false;
			if not self.handbrake then
				brakeTorque = 0.00001;
				self.motor.brakeForce = brakeTorque;
			end;
			if not self.brakereleasePlaying then
				playSample(self.brakereleaseSoundId,1,1,0);
				self.brakereleasePlaying = true;
			end;
		end;

        if self.firstTimeRun then
            WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeed, acceleration, false, self.requiredDriveMode)
        end;
		local ratio = 0;
		local rpmRange = 0;
		if self.gang01 then
			ratio = 12;
			rpmRange = 300;
		elseif self.gang0 then
			ratio = 0;
		elseif self.gang1 then
			ratio = 14;
			rpmRange = 200;
		elseif self.gang2 then
			ratio = 6.5;
			rpmRange = 250;
		elseif self.gang3 then
			ratio = 4.5;
			rpmRange = 250;
		elseif self.gang4 then
			ratio = 3.25;
			rpmRange = 0;
		end;
		self.motor.backwardGearRatio = ratio;
		self.motor.forwardGearRatios = {ratio/2,ratio/1.5,ratio};
		self.motor.rpmFadeOutRange = rpmRange;
		
	end;
		
end;

	
	if self.isMotorStarted and self:getIsActiveForInput() and self.isEntered then
	
	    if self.motor.speedLevel ~= 0 then
			
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
			        self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
			    end;
	    	end;
				
		else
			
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[3] >= 10 then
			            self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
			    end;
	    	end;
			
	    end;
		
	end;

	if self.isEntered then
	if self.attachedTrailer and self.lastSpeed*3600 > 2 and self.lastSpeed*3600 < 10 then
			Utils.setEmittingState(self.exhaustParticleSystems2, true);
		end;
		if not self.attachedTrailer or not self.motor.speedLevel == 0 or self.lastSpeed*3600 < 2 or self.lastSpeed*3600 > 10 then
			Utils.setEmittingState(self.exhaustParticleSystems2, false);
		end;
		if self.attachedTrailer and self.lastSpeed*3600 > 10 then
			Utils.setEmittingState(self.exhaustParticleSystems3, true);
		end;
		if not self.attachedTrailer or self.lastSpeed*3600 < 10 then
			Utils.setEmittingState(self.exhaustParticleSystems3, false);
		end;
		if not self.attachedTrailer and self.lastSpeed*3600 > 2 and self.lastSpeed*3600 < 10 then
			Utils.setEmittingState(self.exhaustParticleSystems4, true);
		end;
		if not self.attachedTrailer and self.lastSpeed*3600 < 2 or self.lastSpeed*3600 > 10 then
			Utils.setEmittingState(self.exhaustParticleSystems4, false);
		end;
		
		if not self.attachedTrailer and self.lastSpeed*3600 > 10 then
			Utils.setEmittingState(self.exhaustParticleSystems5, true);
		end;
		if not self.attachedTrailer and self.lastSpeed*3600 < 10 then
			Utils.setEmittingState(self.exhaustParticleSystems5, false);
		end;
	end;


		setVisibility(self.blizniak, self.blizniakActive);
		setVisibility(self.blizniak2, self.blizniak2Active);
		setVisibility(self.blizniak3, self.blizniak3Active);
		setVisibility(self.blizniak4, self.blizniak4Active);

		if self.isMotorStarted and self.naped ~= nil then
				rotate(self.naped, 0, 0, dt*0.2);
			end;	
		
		
			
local doRotate = self.wajchagazMax or self.wajchagazMin 
	if self.wajchagaz ~= nil and doRotate then
        	local x, y, z = getRotation(self.wajchagaz.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.wajchagaz.maxRot, self.wajchagaz.minRot, 3, self.wajchagaz.rotTime, dt, not self.wajchagazMax);
        	setRotation(self.wajchagaz.node, unpack(newRot));
	end;
	
	
	if self.rotationPartpedalgazu ~= nil then
		local x, y, z = getRotation(self.rotationPartpedalgazu.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpedalgazu.maxRot, self.rotationPartpedalgazu.minRot, 3, self.rotationPartpedalgazu.rotTime, dt, not self.rotationMaxpedalgazu);
		setRotation(self.rotationPartpedalgazu.node, unpack(newRot));
	end;
	

	if self.rotationPartsprzeglo ~= nil then
		local x, y, z = getRotation(self.rotationPartsprzeglo.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartsprzeglo.maxRot, self.rotationPartsprzeglo.minRot, 3, self.rotationPartsprzeglo.rotTime, dt, not self.rotationMaxsprzeglo);
		setRotation(self.rotationPartsprzeglo.node, unpack(newRot));
	end;
	

	if self.rotationPartpedalhamulca ~= nil then
		local x, y, z = getRotation(self.rotationPartpedalhamulca.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpedalhamulca.maxRot, self.rotationPartpedalhamulca.minRot, 3, self.rotationPartpedalhamulca.rotTime, dt, not self.rotationMaxpedalhamulca);
		setRotation(self.rotationPartpedalhamulca.node, unpack(newRot));
	end;
	
	if self.isEntered then
		if Input.isKeyPressed(Input.KEY_w) then
			self.rotationMaxpedalgazu = true;
		else
			self.rotationMaxpedalgazu = false;
		end;
		if self.gang0 then
			self.rotationMaxsprzeglo = true;
		else
			self.rotationMaxsprzeglo = false;
		end;
		if Input.isKeyPressed(Input.KEY_s) then
			self.rotationMaxpedalhamulca = true;
		else
			self.rotationMaxpedalhamulca = false;
		end;
	end;

		


	if self.rotationPartkluczyk ~= nil then
		local x, y, z = getRotation(self.rotationPartkluczyk.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkluczyk.maxRot, self.rotationPartkluczyk.minRot, 3, self.rotationPartkluczyk.rotTime, dt, not self.rotationMaxkluczyk);
		setRotation(self.rotationPartkluczyk.node, unpack(newRot));
	end;
if self.isMotorStarted then
		self.rotationMaxkluczyk = true;
	else
		self.rotationMaxkluczyk = false;
end;	

	  if self.swiatla then
            	self.rotationMaxwlswiatel = true;
			else
				self.rotationMaxwlswiatel = false;
        end;
	
	if self.rotationPartwlswiatel ~= nil then
		local x, y, z = getRotation(self.rotationPartwlswiatel.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwlswiatel.maxRot, self.rotationPartwlswiatel.minRot, 3, self.rotationPartwlswiatel.rotTime, dt, not self.rotationMaxwlswiatel);
		setRotation(self.rotationPartwlswiatel.node, unpack(newRot));
	end;

	if self.rotationPartwajchabiegir ~= nil then
		local x, y, z = getRotation(self.rotationPartwajchabiegir.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajchabiegir.maxRot, self.rotationPartwajchabiegir.minRot, 3,  self.rotationPartwajchabiegir.rotTime, dt, not self.rotationMaxwajchabiegir);
		setRotation(self.rotationPartwajchabiegir.node, unpack(newRot));
	end;	
	
	if self.rotationPartwajchabiegi1 ~= nil then
		local x, y, z = getRotation(self.rotationPartwajchabiegi1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajchabiegi1.maxRot, self.rotationPartwajchabiegi1.minRot, 3, 	self.rotationPartwajchabiegi1.rotTime, dt, not self.rotationMaxwajchabiegi1);
		setRotation(self.rotationPartwajchabiegi1.node, unpack(newRot));
	end;
	
	if self.rotationPartwajchabiegi2 ~= nil then
		local x, y, z = getRotation(self.rotationPartwajchabiegi2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajchabiegi2.maxRot, self.rotationPartwajchabiegi2.minRot, 3, 	self.rotationPartwajchabiegi2.rotTime, dt, not self.rotationMaxwajchabiegi2);
		setRotation(self.rotationPartwajchabiegi2.node, unpack(newRot));
	end
	
	if self.rotationPartwajchabiegi3 ~= nil then
		local x, y, z = getRotation(self.rotationPartwajchabiegi3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajchabiegi3.maxRot, self.rotationPartwajchabiegi3.minRot, 3, self.rotationPartwajchabiegi3.rotTime, dt, not self.rotationMaxwajchabiegi3);
		setRotation(self.rotationPartwajchabiegi3.node, unpack(newRot));
	end;
	
	if self.rotationPartwajchabiegi4 ~= nil then
		local x, y, z = getRotation(self.rotationPartwajchabiegi4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajchabiegi4.maxRot, self.rotationPartwajchabiegi4.minRot, 3, self.rotationPartwajchabiegi4.rotTime, dt, not self.rotationMaxwajchabiegi4);
		setRotation(self.rotationPartwajchabiegi4.node, unpack(newRot));
	end;
	   
        if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.hasEvent(InputBinding.RADIO) then
             if not self.radioSoundPlaying then 
               playSample(self. radioSound, 0, self. radioSoundVolume, 0); 
               self.radioSoundPlaying = true; 
           else 
                stopSample(self. radioSound); 
                self.radioSoundPlaying = false; 
             end;  
          end;
	
end;

function Ursus_5314:draw()

	
	
	
	if self.handbrake then
setTextColor(1,0,0,1);
		renderText(0.77, 0.77, 0.024, "Space: Zwolnij Reczny");
else
	renderText(0.77, 0.77, 0.024, "Space: Zaciagnij Reczny");
end;
	
	if not self.pomoc then
		setTextColor(1,1,1,1);
		renderText(0.80, 0.74, 0.026, "0: Wlacz Pomoc");
	else
		setTextColor(1,1,1,1);
		renderText(0.80, 0.74, 0.026, "0: Wylacz Pomoc");
	end;
	
	if self.pomoc then
	
	
	if self.halogenysActive then
		renderText(0.72, 0.72, 0.021, "z: Wylacz Halogeny przednie");
	else
		renderText(0.72, 0.72, 0.021, "z: Wlacz Halogeny przednie");
	end;
	
	if self.travailsActive then
		renderText(0.72, 0.70, 0.021, "5: Wylacz Halogeny tylne");
	else
		renderText(0.72, 0.70, 0.021, "5: Wlacz Halogeny tylne");
	end;		

	
	if self.kogutAn then
		renderText(0.72, 0.66, 0.021, "7: Wylacz Kogut");
	else
		renderText(0.72, 0.66, 0.021, "7: Wlacz Kogut");
	end;	
	
	if self.lusterkasActive then
		renderText(0.72, 0.62, 0.021, "9: Wylacz Lusterka");
	else
		renderText(0.72, 0.62, 0.021, "9: Wlacz Lusterka");
	end;
	if self.flash then
		renderText(0.72, 0.60, 0.021, "NUM 5: Wylacz Awaryjne");
	else
		renderText(0.72, 0.60, 0.021, "NUM 5: Wlacz Awaryjne");
	end;
	if self.flashLeft then
		renderText(0.72, 0.58, 0.021, "NUM 4: Wylacz Prawy kierunek");
	else
		renderText(0.72, 0.58, 0.021, "NUM 4: Wlacz Prawy kierunek");
	end;
	if self.flashRight then
		renderText(0.72, 0.56, 0.021, "NUM 6: Wylacz Lewy kierunek");
	else
		renderText(0.72, 0.56, 0.021, "NUM 6: Wlacz Lewy kierunek");
	end;
	renderText(0.72, 0.54, 0.021, "NUM 8/9: Otworz/zamknij drzwi Lewe");
	renderText(0.72, 0.52, 0.021, "NUM 2/3: Otworz/zamknij drzwi Prawe");

if self.wycieraczka then
		renderText(0.72, 0.50, 0.021, "NUM 7: Wylacz wycieraczke");
	else
		renderText(0.72, 0.50, 0.021, "NUM 7: Wlacz wycieraczke");
	end;
renderText(0.72, 0.48, 0.021, "Page up/down: Wyzszy/nizszy bieg");



if self.radioSoundPlaying then
		renderText(0.72, 0.42, 0.021, "R: Wylacz Radio");
	else
		renderText(0.72, 0.42, 0.021, "R: Wlacz Radio");
	end;
end;


if self.isEntered then
		if self.ursushudOverlay ~= nil then
			self.ursushudOverlay:render();
		end;

		if self.handbrake then
			setTextBold(true);
			setTextColor(1,0,0,1);
			if Input.isKeyPressed(Input.KEY_w) then
				setTextBold(true);
				setTextColor(1,0,0,1);
				renderText(0.4, 0.3, 0.05, "Zwolnij Reczny");
			end;
				
		end;
		setTextColor(0.0,0.0,0.0,1);
		setTextBold(true);
		
		setTextBold(true);
		if not self.skrzynia then
		
			if self.gang01 then
				setTextColor(0,1,0,1);
				renderText(0.71, 0.11, 0.035, "R");
			else
				setTextColor(0.1,0.1,0.1,1);
				renderText(0.71, 0.11, 0.035, "R");
			end;
			if self.gang0 then
				setTextColor(1,0,0,1);
				renderText(0.7525, 0.055, 0.035, "N");
			else
				setTextColor(1,1,1,1);
				renderText(0.7525, 0.055, 0.035, "N");
			end;
			if self.gang1 then
				setTextColor(0,1,0,1);
				renderText(0.7325, 0.01, 0.035, "1");
			else
				setTextColor(0.1,0.1,0.1,1);
				renderText(0.7325, 0.01, 0.035, "1");
			end;
			if self.gang3 then
				setTextColor(0,1,0,1);
				renderText(0.7725, 0.01, 0.035, "3");
			else
				setTextColor(0.1,0.1,0.1,1);
				renderText(0.7725, 0.01, 0.035, "3");
			end;
			if self.gang2 then
				setTextColor(0,1,0,1);
				renderText(0.7925, 0.11, 0.035, "2");
			else
				setTextColor(0.1,0.1,0.1,1);
				renderText(0.7925, 0.11, 0.035, "2");
			end;
			if self.gang4 then
				setTextColor(0,1,0,1);
				renderText(0.7525, 0.11, 0.035, "4");
			else
				setTextColor(0.1,0.1,0.1,1);
				renderText(0.7525, 0.11, 0.035, "4");
			end;

		end;
		end;
if self.isMotorStarted then	
        if self.motor.speedLevel ~= 0 then
            g_currentMission:addExtraPrintText("RPM: +/-:   "..string.format("%d RPM",self.motor.maxRpm[self.motor.speedLevel]).."");
	    else
            g_currentMission:addExtraPrintText("RPM: +/-:   "..string.format("%d RPM",self.motor.maxRpm[3]).."");
	    end;
	end;
end;

function Ursus_5314:onEnter()

   self.handbrake = true;
	Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function Ursus_5314:onLeave()

	

self.handbrake = false;
    self.lusterkasActive = false;
	self.kogutAn = false;
    for i=1, self.kogutAnz do
       setVisibility(self.kogut[i].light, self.kogutAn);
    end;
  
   	self.gang0 = true;
	self.neutral = true;
	self.gang02 = false;
	self.gang01 = false;
	self.gang1 = false;
	self.gang2 = false;
	self.gang3 = false;
	self.gang4 = false;
	self.forward = false;
	self.reverseGear = false;
	self.handbrake = false;
	Utils.setEmittingState(self.exhaustParticleSystems2, false);
	Utils.setEmittingState(self.exhaustParticleSystems3, false);
	Utils.setEmittingState(self.exhaustParticleSystems4, false);
	Utils.setEmittingState(self.exhaustParticleSystems5, false);
 
end;

function Ursus_5314:delete()
	delete(self.radioSound);

end;

function Ursus_5314:mouseEvent(posX, posY, isDown, isUp, button)

end;


